<manifest version="1.0" type="device" target-level="4">
    <hal format="hidl">
        <name>android.hardware.audio</name>
        <transport>hwbinder</transport>
        <fqname>@5.0::IDevicesFactory/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.audio.effect</name>
        <transport>hwbinder</transport>
        <fqname>@5.0::IEffectsFactory/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.biometrics.fingerprint</name>
        <transport>hwbinder</transport>
        <fqname>@2.1::IBiometricsFingerprint/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.bluetooth</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IBluetoothHci/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.bluetooth.audio</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::IBluetoothAudioProvidersFactory/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.camera.provider</name>
        <transport>hwbinder</transport>
        <fqname>@2.4::ICameraProvider/internal/0</fqname>
        <fqname>@2.4::ICameraProvider/virtual/0</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.configstore</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::ISurfaceFlingerConfigs/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.drm</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::ICryptoFactory/default</fqname>
        <fqname>@1.0::IDrmFactory/default</fqname>
        <fqname>@1.2::ICryptoFactory/clearkey</fqname>
        <fqname>@1.2::ICryptoFactory/widevine</fqname>
        <fqname>@1.2::IDrmFactory/clearkey</fqname>
        <fqname>@1.2::IDrmFactory/widevine</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.gatekeeper</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IGatekeeper/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.gnss</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IGnss/default</fqname>
        <fqname>@2.0::IGnss/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.graphics.allocator</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::IAllocator/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.graphics.composer</name>
        <transport>hwbinder</transport>
        <fqname>@2.1::IComposer/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.graphics.mapper</name>
        <transport arch="32+64">passthrough</transport>
        <fqname>@2.1::IMapper/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.health</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::IHealth/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.keymaster</name>
        <transport>hwbinder</transport>
        <fqname>@3.0::IKeymasterDevice/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.light</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::ILight/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.media.omx</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IOmx/default</fqname>
        <fqname>@1.0::IOmxStore/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.memtrack</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IMemtrack/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.power</name>
        <transport>hwbinder</transport>
        <fqname>@1.3::IPower/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.radio</name>
        <transport>hwbinder</transport>
        <fqname>@1.2::IRadio/em1</fqname>
        <fqname>@1.2::IRadio/em2</fqname>
        <fqname>@1.2::IRadio/imsAospSlot1</fqname>
        <fqname>@1.2::IRadio/imsAospSlot2</fqname>
        <fqname>@1.2::IRadio/se1</fqname>
        <fqname>@1.2::IRadio/se2</fqname>
        <fqname>@1.2::IRadio/slot1</fqname>
        <fqname>@1.2::IRadio/slot2</fqname>
        <fqname>@1.2::ISap/slot1</fqname>
        <fqname>@1.2::ISap/slot2</fqname>
        <fqname>@1.4::IRadio/em1</fqname>
        <fqname>@1.4::IRadio/em2</fqname>
        <fqname>@1.4::IRadio/imsAospSlot1</fqname>
        <fqname>@1.4::IRadio/imsAospSlot2</fqname>
        <fqname>@1.4::IRadio/se1</fqname>
        <fqname>@1.4::IRadio/se2</fqname>
        <fqname>@1.4::IRadio/slot1</fqname>
        <fqname>@1.4::IRadio/slot2</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.radio.config</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IRadioConfig/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.renderscript</name>
        <transport arch="32+64">passthrough</transport>
        <fqname>@1.0::IDevice/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.secure_element</name>
        <transport>hwbinder</transport>
    </hal>
    <hal format="hidl">
        <name>android.hardware.sensors</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::ISensors/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.thermal</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IThermal/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.usb</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IUsb/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.vibrator</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IVibrator/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.wifi</name>
        <transport>hwbinder</transport>
        <fqname>@1.3::IWifi/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.wifi.hostapd</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IHostapd/default</fqname>
    </hal>
    <hal format="hidl">
        <name>android.hardware.wifi.supplicant</name>
        <transport>hwbinder</transport>
        <fqname>@1.2::ISupplicant/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.audioremote</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IAudioRemoteConnect/default</fqname>
        <fqname>@1.1::IAudioRemoteConnect/virtualmodem</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.biometrics.fingerprint</name>
        <transport>hwbinder</transport>
        <fqname>@2.2::IExtBiometricsFingerprint/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.biometrics.hwfacerecognize</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::IBiometricsFaceRecognize/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.camera.camResource</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IHwCameraResourceService/huawei.cameraresource.service</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.camera.cfgsvr</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IHwCamCfgSvr/huawei.camera.cfgsvr</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.camera.factory</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::ICameraFactory/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.camera.vircamera</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IVirCameraChannel/virtualcamera.register</fqname>
        <fqname>@1.0::IVirCameraChannel/virtualcamera.streamchange</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.eid</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IEid/eid</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.huaweiantitheft</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IHuaweiAntiTheft/huaweiantitheft</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.huaweisigntool</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::ISignTool/huaweisigntool</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hwdisplay</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IDisplay/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hwdisplay.displayengine</name>
        <transport>hwbinder</transport>
        <fqname>@1.2::IDisplayEngineWrapper/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hwfactoryinterface</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IHwFactoryInterface/hwfactoryinterface_hal</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hwfs</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IHwfs/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hwhiview</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IHwHiviewInterface/hwhiview_hal</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hwstp</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IHwStp/hwstp</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hwupdate</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IHwUpdate/hwupdate_hal</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.hwvibrator</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IHWVibrator/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.iawareperf</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IUniPerf/uniperf</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.iawareperfpolicy</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IPerfPolicy/perfpolicy</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.kds</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IKds/kds</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.libteec</name>
        <transport>hwbinder</transport>
        <fqname>@3.0::ILibteecGlobal/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.light</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::ILight/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.mtkradio</name>
        <transport>hwbinder</transport>
        <fqname>@1.5::IMtkRadioEx/imsSlot1</fqname>
        <fqname>@1.5::IMtkRadioEx/imsSlot2</fqname>
        <fqname>@1.5::IMtkRadioEx/mtkAssist1</fqname>
        <fqname>@1.5::IMtkRadioEx/mtkAssist2</fqname>
        <fqname>@1.5::IMtkRadioEx/mtkCap1</fqname>
        <fqname>@1.5::IMtkRadioEx/mtkCap2</fqname>
        <fqname>@1.5::IMtkRadioEx/mtkEm1</fqname>
        <fqname>@1.5::IMtkRadioEx/mtkEm2</fqname>
        <fqname>@1.5::IMtkRadioEx/mtkRcs1</fqname>
        <fqname>@1.5::IMtkRadioEx/mtkRcs2</fqname>
        <fqname>@1.5::IMtkRadioEx/mtkSe1</fqname>
        <fqname>@1.5::IMtkRadioEx/mtkSe2</fqname>
        <fqname>@1.5::IMtkRadioEx/mtkSlot1</fqname>
        <fqname>@1.5::IMtkRadioEx/mtkSlot2</fqname>
        <fqname>@1.5::IMtkRadioEx/mtkSmartRatSwitch1</fqname>
        <fqname>@1.5::IMtkRadioEx/mtkSmartRatSwitch2</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.nnx</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::INnxServerListener/default</fqname>
        <fqname>@1.0::INnxService/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.power</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IHWPower/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.radio</name>
        <transport>hwbinder</transport>
        <fqname>@2.1::IRadio/slot1</fqname>
        <fqname>@2.1::IRadio/slot2</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.radio_radar</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IRadioRadar/slot1</fqname>
        <fqname>@1.0::IRadioRadar/slot2</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.radioenhance</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IRadioenhance/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.sensors</name>
        <transport>hwbinder</transport>
        <fqname>@1.2::ISensors/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.tp</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::ITouchscreen/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.huawei.hardware.wifi</name>
        <transport>hwbinder</transport>
        <fqname>@1.2::IHwWifiExt/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.mediatek.hardware.atci</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IAtcid/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.mediatek.hardware.camera.isphal</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IISPModule/internal/0</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.mediatek.hardware.engineermode</name>
        <transport>hwbinder</transport>
        <fqname>@1.2::IEmd/EmHidlServer</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.mediatek.hardware.fm</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IFmRadio/fm_hidl_service</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.mediatek.hardware.lbs</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::ILbs/AgpsDebugInterface</fqname>
        <fqname>@1.0::ILbs/AgpsInterface</fqname>
        <fqname>@1.0::ILbs/mtk_agps2framework</fqname>
        <fqname>@1.0::ILbs/mtk_debugService2mnld</fqname>
        <fqname>@1.0::ILbs/mtk_framework2agps</fqname>
        <fqname>@1.0::ILbs/mtk_lbs_log_v2s</fqname>
        <fqname>@1.0::ILbs/mtk_lppe_socket_agps</fqname>
        <fqname>@1.0::ILbs/mtk_lppe_socket_bt</fqname>
        <fqname>@1.0::ILbs/mtk_lppe_socket_ipaddr</fqname>
        <fqname>@1.0::ILbs/mtk_lppe_socket_lbs</fqname>
        <fqname>@1.0::ILbs/mtk_lppe_socket_network</fqname>
        <fqname>@1.0::ILbs/mtk_lppe_socket_sensor</fqname>
        <fqname>@1.0::ILbs/mtk_lppe_socket_wlan</fqname>
        <fqname>@1.0::ILbs/mtk_meta2mnld</fqname>
        <fqname>@1.0::ILbs/mtk_mnld2debugService</fqname>
        <fqname>@1.0::ILbs/mtk_mnld2mtklogger</fqname>
        <fqname>@1.0::ILbs/mtk_mnld2nlputils</fqname>
        <fqname>@1.0::ILbs/mtk_mtklogger2mnld</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.mediatek.hardware.mdmonitor</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IMDMonitorService/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.mediatek.hardware.mms</name>
        <transport>hwbinder</transport>
        <fqname>@1.6::IMms/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.mediatek.hardware.mtkcodecservice</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::IMtkCodecService/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.mediatek.hardware.mtkpower</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IMtkPerf/default</fqname>
        <fqname>@1.0::IMtkPower/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.mediatek.hardware.netdagent</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::INetdagent/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.mediatek.hardware.nvram</name>
        <transport>hwbinder</transport>
        <fqname>@1.1::INvram/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.mediatek.hardware.power</name>
        <transport>hwbinder</transport>
        <fqname>@2.1::IPower/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.mediatek.hardware.pplagent</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IPplAgent/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.mediatek.hardware.pq</name>
        <transport>hwbinder</transport>
        <fqname>@2.6::IPictureQuality/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.mediatek.hardware.videotelephony</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::IVideoTelephony/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.mediatek.hardware.vpu</name>
        <transport>hwbinder</transport>
        <fqname>@1.0::Ivpu/default</fqname>
    </hal>
    <hal format="hidl">
        <name>vendor.mediatek.hardware.wifi.supplicant</name>
        <transport>hwbinder</transport>
        <fqname>@2.0::ISupplicant/default</fqname>
    </hal>
</manifest>
